/* Quat.c generated by valac 0.54.8, the Vala compiler
 * generated from Quat.vala, do not modify */

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <string.h>

#define ENGINE_QUAT_SLERP_THRESHOLD 0.9995f
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define ENGINE_TYPE_QUAT (engine_quat_get_type ())
typedef struct _EngineQuat EngineQuat;

#define ENGINE_TYPE_VEC3 (engine_vec3_get_type ())
typedef struct _EngineVec3 EngineVec3;

struct _EngineQuat {
	gfloat _w;
	gfloat _x;
	gfloat _y;
	gfloat _z;
};

struct _EngineVec3 {
	gfloat x;
	gfloat y;
	gfloat z;
};

VALA_EXTERN GType engine_quat_get_type (void) G_GNUC_CONST ;
VALA_EXTERN EngineQuat* engine_quat_dup (const EngineQuat* self);
VALA_EXTERN void engine_quat_free (EngineQuat* self);
VALA_EXTERN void engine_quat_init (EngineQuat *self);
static void engine_quat_set_w (EngineQuat* self,
                        gfloat value);
VALA_EXTERN void engine_quat_init_from_euler (EngineQuat *self,
                                  gfloat yaw,
                                  gfloat pitch,
                                  gfloat roll);
static void engine_quat_init_values (EngineQuat *self,
                              gfloat yaw,
                              gfloat pitch,
                              gfloat roll);
VALA_EXTERN GType engine_vec3_get_type (void) G_GNUC_CONST ;
VALA_EXTERN EngineVec3* engine_vec3_dup (const EngineVec3* self);
VALA_EXTERN void engine_vec3_free (EngineVec3* self);
VALA_EXTERN void engine_quat_init_from_euler_vec (EngineQuat *self,
                                      EngineVec3* vec);
VALA_EXTERN void engine_quat_init_from_direction (EngineQuat *self,
                                      EngineVec3* from,
                                      EngineVec3* to);
VALA_EXTERN void engine_vec3_plus (EngineVec3 *self,
                       EngineVec3* other,
                       EngineVec3* result);
VALA_EXTERN void engine_vec3_normalize (EngineVec3 *self,
                            EngineVec3* result);
VALA_EXTERN gfloat engine_vec3_dot (EngineVec3 *self,
                        EngineVec3* other);
static void engine_quat_set_x (EngineQuat* self,
                        gfloat value);
static void engine_quat_set_y (EngineQuat* self,
                        gfloat value);
static void engine_quat_set_z (EngineQuat* self,
                        gfloat value);
VALA_EXTERN void engine_quat_init_vals (EngineQuat *self,
                            gfloat w,
                            gfloat x,
                            gfloat y,
                            gfloat z);
VALA_EXTERN gboolean engine_quat_equals (EngineQuat *self,
                             EngineQuat* other);
VALA_EXTERN gfloat engine_quat_get_w (EngineQuat* self);
VALA_EXTERN gfloat engine_quat_get_x (EngineQuat* self);
VALA_EXTERN gfloat engine_quat_get_y (EngineQuat* self);
VALA_EXTERN gfloat engine_quat_get_z (EngineQuat* self);
VALA_EXTERN gfloat engine_quat_len (EngineQuat *self);
VALA_EXTERN void engine_quat_mul (EngineQuat *self,
                      EngineQuat* other,
                      EngineQuat* result);
VALA_EXTERN void engine_quat_mul_scalar (EngineQuat *self,
                             gfloat scalar,
                             EngineQuat* result);
VALA_EXTERN void engine_quat_div_scalar (EngineQuat *self,
                             gfloat scalar,
                             EngineQuat* result);
VALA_EXTERN gfloat engine_quat_dot (EngineQuat *self,
                        EngineQuat* other);
VALA_EXTERN void engine_quat_inv (EngineQuat *self,
                      EngineQuat* result);
VALA_EXTERN void engine_quat_conjugate (EngineQuat *self,
                            EngineQuat* result);
VALA_EXTERN void engine_quat_norm (EngineQuat *self,
                       EngineQuat* result);
VALA_EXTERN void engine_quat_neg (EngineQuat *self,
                      EngineQuat* result);
VALA_EXTERN void engine_quat_to_euler (EngineQuat *self,
                           EngineVec3* result);
VALA_EXTERN void engine_vec3_init (EngineVec3 *self,
                       gfloat x,
                       gfloat y,
                       gfloat z);
VALA_EXTERN void engine_vec3_div_scalar (EngineVec3 *self,
                             gfloat scalar,
                             EngineVec3* result);
VALA_EXTERN void engine_quat_slerp (EngineQuat* from,
                        EngineQuat* to,
                        gfloat t,
                        EngineQuat* result);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

void
engine_quat_init (EngineQuat *self)
{
	memset (self, 0, sizeof (EngineQuat));
	engine_quat_set_w (&(*self), (gfloat) 1);
}

void
engine_quat_init_from_euler (EngineQuat *self,
                             gfloat yaw,
                             gfloat pitch,
                             gfloat roll)
{
	memset (self, 0, sizeof (EngineQuat));
	engine_quat_init_values (&(*self), yaw, pitch, roll);
}

void
engine_quat_init_from_euler_vec (EngineQuat *self,
                                 EngineVec3* vec)
{
	EngineVec3 _tmp0_;
	EngineVec3 _tmp1_;
	EngineVec3 _tmp2_;
	g_return_if_fail (vec != NULL);
	memset (self, 0, sizeof (EngineQuat));
	_tmp0_ = *vec;
	_tmp1_ = *vec;
	_tmp2_ = *vec;
	engine_quat_init_values (&(*self), _tmp0_.x, _tmp1_.y, _tmp2_.z);
}

void
engine_quat_init_from_direction (EngineQuat *self,
                                 EngineVec3* from,
                                 EngineVec3* to)
{
	EngineVec3 h = {0};
	EngineVec3 _tmp0_;
	EngineVec3 _tmp1_ = {0};
	EngineVec3 _tmp2_ = {0};
	EngineVec3 _tmp3_;
	EngineVec3 _tmp4_;
	EngineVec3 _tmp5_;
	EngineVec3 _tmp6_;
	EngineVec3 _tmp7_;
	EngineVec3 _tmp8_;
	EngineVec3 _tmp9_;
	EngineVec3 _tmp10_;
	EngineVec3 _tmp11_;
	EngineVec3 _tmp12_;
	EngineVec3 _tmp13_;
	EngineVec3 _tmp14_;
	EngineVec3 _tmp15_;
	g_return_if_fail (from != NULL);
	g_return_if_fail (to != NULL);
	memset (self, 0, sizeof (EngineQuat));
	_tmp0_ = *to;
	engine_vec3_plus (from, &_tmp0_, &_tmp1_);
	engine_vec3_normalize (&_tmp1_, &_tmp2_);
	h = _tmp2_;
	_tmp3_ = h;
	engine_quat_set_w (&(*self), engine_vec3_dot (from, &_tmp3_));
	_tmp4_ = *from;
	_tmp5_ = h;
	_tmp6_ = *from;
	_tmp7_ = h;
	engine_quat_set_x (&(*self), (_tmp4_.y * _tmp5_.z) - (_tmp6_.z * _tmp7_.y));
	_tmp8_ = *from;
	_tmp9_ = h;
	_tmp10_ = *from;
	_tmp11_ = h;
	engine_quat_set_y (&(*self), (_tmp8_.z * _tmp9_.x) - (_tmp10_.x * _tmp11_.z));
	_tmp12_ = *from;
	_tmp13_ = h;
	_tmp14_ = *from;
	_tmp15_ = h;
	engine_quat_set_z (&(*self), (_tmp12_.x * _tmp13_.y) - (_tmp14_.y * _tmp15_.x));
}

static void
engine_quat_init_values (EngineQuat *self,
                         gfloat yaw,
                         gfloat pitch,
                         gfloat roll)
{
	gfloat tau = 0.0F;
	gfloat t0 = 0.0F;
	gfloat t1 = 0.0F;
	gfloat t2 = 0.0F;
	gfloat t3 = 0.0F;
	gfloat t4 = 0.0F;
	gfloat t5 = 0.0F;
	tau = ((gfloat) G_PI) / 2;
	yaw = yaw * tau;
	pitch = pitch * tau;
	roll = roll * tau;
	t0 = (gfloat) cos ((gdouble) roll);
	t1 = (gfloat) sin ((gdouble) roll);
	t2 = (gfloat) cos ((gdouble) pitch);
	t3 = (gfloat) sin ((gdouble) pitch);
	t4 = (gfloat) cos ((gdouble) yaw);
	t5 = (gfloat) sin ((gdouble) yaw);
	engine_quat_set_w (&(*self), ((t0 * t2) * t4) + ((t1 * t3) * t5));
	engine_quat_set_x (&(*self), ((t0 * t3) * t4) - ((t1 * t2) * t5));
	engine_quat_set_y (&(*self), ((t0 * t2) * t5) + ((t1 * t3) * t4));
	engine_quat_set_z (&(*self), ((t1 * t2) * t4) - ((t0 * t3) * t5));
}

void
engine_quat_init_vals (EngineQuat *self,
                       gfloat w,
                       gfloat x,
                       gfloat y,
                       gfloat z)
{
	memset (self, 0, sizeof (EngineQuat));
	engine_quat_set_w (&(*self), w);
	engine_quat_set_x (&(*self), x);
	engine_quat_set_y (&(*self), y);
	engine_quat_set_z (&(*self), z);
}

gboolean
engine_quat_equals (EngineQuat *self,
                    EngineQuat* other)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gfloat _tmp3_;
	gfloat _tmp4_;
	EngineQuat _tmp5_;
	gfloat _tmp6_;
	gfloat _tmp7_;
	gboolean result = FALSE;
	g_return_val_if_fail (other != NULL, FALSE);
	_tmp3_ = engine_quat_get_w (&(*self));
	_tmp4_ = _tmp3_;
	_tmp5_ = *other;
	_tmp6_ = engine_quat_get_w (&_tmp5_);
	_tmp7_ = _tmp6_;
	if (_tmp4_ == _tmp7_) {
		gfloat _tmp8_;
		gfloat _tmp9_;
		EngineQuat _tmp10_;
		gfloat _tmp11_;
		gfloat _tmp12_;
		_tmp8_ = engine_quat_get_x (&(*self));
		_tmp9_ = _tmp8_;
		_tmp10_ = *other;
		_tmp11_ = engine_quat_get_x (&_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp2_ = _tmp9_ == _tmp12_;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		gfloat _tmp13_;
		gfloat _tmp14_;
		EngineQuat _tmp15_;
		gfloat _tmp16_;
		gfloat _tmp17_;
		_tmp13_ = engine_quat_get_y (&(*self));
		_tmp14_ = _tmp13_;
		_tmp15_ = *other;
		_tmp16_ = engine_quat_get_y (&_tmp15_);
		_tmp17_ = _tmp16_;
		_tmp1_ = _tmp14_ == _tmp17_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gfloat _tmp18_;
		gfloat _tmp19_;
		EngineQuat _tmp20_;
		gfloat _tmp21_;
		gfloat _tmp22_;
		_tmp18_ = engine_quat_get_z (&(*self));
		_tmp19_ = _tmp18_;
		_tmp20_ = *other;
		_tmp21_ = engine_quat_get_z (&_tmp20_);
		_tmp22_ = _tmp21_;
		_tmp0_ = _tmp19_ == _tmp22_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

gfloat
engine_quat_len (EngineQuat *self)
{
	gfloat _tmp0_;
	gfloat _tmp1_;
	gfloat _tmp2_;
	gfloat _tmp3_;
	gfloat _tmp4_;
	gfloat _tmp5_;
	gfloat _tmp6_;
	gfloat _tmp7_;
	gfloat _tmp8_;
	gfloat _tmp9_;
	gfloat _tmp10_;
	gfloat _tmp11_;
	gfloat _tmp12_;
	gfloat _tmp13_;
	gfloat _tmp14_;
	gfloat _tmp15_;
	gfloat result = 0.0F;
	_tmp0_ = engine_quat_get_w (&(*self));
	_tmp1_ = _tmp0_;
	_tmp2_ = engine_quat_get_w (&(*self));
	_tmp3_ = _tmp2_;
	_tmp4_ = engine_quat_get_x (&(*self));
	_tmp5_ = _tmp4_;
	_tmp6_ = engine_quat_get_x (&(*self));
	_tmp7_ = _tmp6_;
	_tmp8_ = engine_quat_get_y (&(*self));
	_tmp9_ = _tmp8_;
	_tmp10_ = engine_quat_get_y (&(*self));
	_tmp11_ = _tmp10_;
	_tmp12_ = engine_quat_get_z (&(*self));
	_tmp13_ = _tmp12_;
	_tmp14_ = engine_quat_get_z (&(*self));
	_tmp15_ = _tmp14_;
	result = (gfloat) sqrt ((gdouble) ((((_tmp1_ * _tmp3_) + (_tmp5_ * _tmp7_)) + (_tmp9_ * _tmp11_)) + (_tmp13_ * _tmp15_)));
	return result;
}

void
engine_quat_mul (EngineQuat *self,
                 EngineQuat* other,
                 EngineQuat* result)
{
	gfloat A = 0.0F;
	gfloat _tmp0_;
	gfloat _tmp1_;
	gfloat _tmp2_;
	gfloat _tmp3_;
	EngineQuat _tmp4_;
	gfloat _tmp5_;
	gfloat _tmp6_;
	EngineQuat _tmp7_;
	gfloat _tmp8_;
	gfloat _tmp9_;
	gfloat B = 0.0F;
	gfloat _tmp10_;
	gfloat _tmp11_;
	gfloat _tmp12_;
	gfloat _tmp13_;
	EngineQuat _tmp14_;
	gfloat _tmp15_;
	gfloat _tmp16_;
	EngineQuat _tmp17_;
	gfloat _tmp18_;
	gfloat _tmp19_;
	gfloat C = 0.0F;
	gfloat _tmp20_;
	gfloat _tmp21_;
	gfloat _tmp22_;
	gfloat _tmp23_;
	EngineQuat _tmp24_;
	gfloat _tmp25_;
	gfloat _tmp26_;
	EngineQuat _tmp27_;
	gfloat _tmp28_;
	gfloat _tmp29_;
	gfloat D = 0.0F;
	gfloat _tmp30_;
	gfloat _tmp31_;
	gfloat _tmp32_;
	gfloat _tmp33_;
	EngineQuat _tmp34_;
	gfloat _tmp35_;
	gfloat _tmp36_;
	EngineQuat _tmp37_;
	gfloat _tmp38_;
	gfloat _tmp39_;
	gfloat E = 0.0F;
	gfloat _tmp40_;
	gfloat _tmp41_;
	gfloat _tmp42_;
	gfloat _tmp43_;
	EngineQuat _tmp44_;
	gfloat _tmp45_;
	gfloat _tmp46_;
	EngineQuat _tmp47_;
	gfloat _tmp48_;
	gfloat _tmp49_;
	gfloat F = 0.0F;
	gfloat _tmp50_;
	gfloat _tmp51_;
	gfloat _tmp52_;
	gfloat _tmp53_;
	EngineQuat _tmp54_;
	gfloat _tmp55_;
	gfloat _tmp56_;
	EngineQuat _tmp57_;
	gfloat _tmp58_;
	gfloat _tmp59_;
	gfloat G = 0.0F;
	gfloat _tmp60_;
	gfloat _tmp61_;
	gfloat _tmp62_;
	gfloat _tmp63_;
	EngineQuat _tmp64_;
	gfloat _tmp65_;
	gfloat _tmp66_;
	EngineQuat _tmp67_;
	gfloat _tmp68_;
	gfloat _tmp69_;
	gfloat H = 0.0F;
	gfloat _tmp70_;
	gfloat _tmp71_;
	gfloat _tmp72_;
	gfloat _tmp73_;
	EngineQuat _tmp74_;
	gfloat _tmp75_;
	gfloat _tmp76_;
	EngineQuat _tmp77_;
	gfloat _tmp78_;
	gfloat _tmp79_;
	EngineQuat _tmp80_ = {0};
	g_return_if_fail (other != NULL);
	_tmp0_ = engine_quat_get_w (&(*self));
	_tmp1_ = _tmp0_;
	_tmp2_ = engine_quat_get_x (&(*self));
	_tmp3_ = _tmp2_;
	_tmp4_ = *other;
	_tmp5_ = engine_quat_get_w (&_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = *other;
	_tmp8_ = engine_quat_get_x (&_tmp7_);
	_tmp9_ = _tmp8_;
	A = (_tmp1_ + _tmp3_) * (_tmp6_ + _tmp9_);
	_tmp10_ = engine_quat_get_z (&(*self));
	_tmp11_ = _tmp10_;
	_tmp12_ = engine_quat_get_y (&(*self));
	_tmp13_ = _tmp12_;
	_tmp14_ = *other;
	_tmp15_ = engine_quat_get_y (&_tmp14_);
	_tmp16_ = _tmp15_;
	_tmp17_ = *other;
	_tmp18_ = engine_quat_get_z (&_tmp17_);
	_tmp19_ = _tmp18_;
	B = (_tmp11_ - _tmp13_) * (_tmp16_ - _tmp19_);
	_tmp20_ = engine_quat_get_w (&(*self));
	_tmp21_ = _tmp20_;
	_tmp22_ = engine_quat_get_x (&(*self));
	_tmp23_ = _tmp22_;
	_tmp24_ = *other;
	_tmp25_ = engine_quat_get_y (&_tmp24_);
	_tmp26_ = _tmp25_;
	_tmp27_ = *other;
	_tmp28_ = engine_quat_get_z (&_tmp27_);
	_tmp29_ = _tmp28_;
	C = (_tmp21_ - _tmp23_) * (_tmp26_ + _tmp29_);
	_tmp30_ = engine_quat_get_y (&(*self));
	_tmp31_ = _tmp30_;
	_tmp32_ = engine_quat_get_z (&(*self));
	_tmp33_ = _tmp32_;
	_tmp34_ = *other;
	_tmp35_ = engine_quat_get_w (&_tmp34_);
	_tmp36_ = _tmp35_;
	_tmp37_ = *other;
	_tmp38_ = engine_quat_get_x (&_tmp37_);
	_tmp39_ = _tmp38_;
	D = (_tmp31_ + _tmp33_) * (_tmp36_ - _tmp39_);
	_tmp40_ = engine_quat_get_x (&(*self));
	_tmp41_ = _tmp40_;
	_tmp42_ = engine_quat_get_z (&(*self));
	_tmp43_ = _tmp42_;
	_tmp44_ = *other;
	_tmp45_ = engine_quat_get_x (&_tmp44_);
	_tmp46_ = _tmp45_;
	_tmp47_ = *other;
	_tmp48_ = engine_quat_get_y (&_tmp47_);
	_tmp49_ = _tmp48_;
	E = (_tmp41_ + _tmp43_) * (_tmp46_ + _tmp49_);
	_tmp50_ = engine_quat_get_x (&(*self));
	_tmp51_ = _tmp50_;
	_tmp52_ = engine_quat_get_z (&(*self));
	_tmp53_ = _tmp52_;
	_tmp54_ = *other;
	_tmp55_ = engine_quat_get_x (&_tmp54_);
	_tmp56_ = _tmp55_;
	_tmp57_ = *other;
	_tmp58_ = engine_quat_get_y (&_tmp57_);
	_tmp59_ = _tmp58_;
	F = (_tmp51_ - _tmp53_) * (_tmp56_ - _tmp59_);
	_tmp60_ = engine_quat_get_w (&(*self));
	_tmp61_ = _tmp60_;
	_tmp62_ = engine_quat_get_y (&(*self));
	_tmp63_ = _tmp62_;
	_tmp64_ = *other;
	_tmp65_ = engine_quat_get_w (&_tmp64_);
	_tmp66_ = _tmp65_;
	_tmp67_ = *other;
	_tmp68_ = engine_quat_get_z (&_tmp67_);
	_tmp69_ = _tmp68_;
	G = (_tmp61_ + _tmp63_) * (_tmp66_ - _tmp69_);
	_tmp70_ = engine_quat_get_w (&(*self));
	_tmp71_ = _tmp70_;
	_tmp72_ = engine_quat_get_y (&(*self));
	_tmp73_ = _tmp72_;
	_tmp74_ = *other;
	_tmp75_ = engine_quat_get_w (&_tmp74_);
	_tmp76_ = _tmp75_;
	_tmp77_ = *other;
	_tmp78_ = engine_quat_get_z (&_tmp77_);
	_tmp79_ = _tmp78_;
	H = (_tmp71_ - _tmp73_) * (_tmp76_ + _tmp79_);
	engine_quat_init_vals (&_tmp80_, B + (((((-E) - F) + G) + H) / 2), A - ((((E + F) + G) + H) / 2), C + ((((E - F) + G) - H) / 2), D + ((((E - F) - G) + H) / 2));
	*result = _tmp80_;
	return;
}

void
engine_quat_mul_scalar (EngineQuat *self,
                        gfloat scalar,
                        EngineQuat* result)
{
	gfloat _tmp0_;
	gfloat _tmp1_;
	gfloat _tmp2_;
	gfloat _tmp3_;
	gfloat _tmp4_;
	gfloat _tmp5_;
	gfloat _tmp6_;
	gfloat _tmp7_;
	EngineQuat _tmp8_ = {0};
	_tmp0_ = engine_quat_get_w (&(*self));
	_tmp1_ = _tmp0_;
	_tmp2_ = engine_quat_get_x (&(*self));
	_tmp3_ = _tmp2_;
	_tmp4_ = engine_quat_get_y (&(*self));
	_tmp5_ = _tmp4_;
	_tmp6_ = engine_quat_get_z (&(*self));
	_tmp7_ = _tmp6_;
	engine_quat_init_vals (&_tmp8_, _tmp1_ * scalar, _tmp3_ * scalar, _tmp5_ * scalar, _tmp7_ * scalar);
	*result = _tmp8_;
	return;
}

void
engine_quat_div_scalar (EngineQuat *self,
                        gfloat scalar,
                        EngineQuat* result)
{
	gfloat _tmp0_;
	gfloat _tmp1_;
	gfloat _tmp2_;
	gfloat _tmp3_;
	gfloat _tmp4_;
	gfloat _tmp5_;
	gfloat _tmp6_;
	gfloat _tmp7_;
	EngineQuat _tmp8_ = {0};
	_tmp0_ = engine_quat_get_w (&(*self));
	_tmp1_ = _tmp0_;
	_tmp2_ = engine_quat_get_x (&(*self));
	_tmp3_ = _tmp2_;
	_tmp4_ = engine_quat_get_y (&(*self));
	_tmp5_ = _tmp4_;
	_tmp6_ = engine_quat_get_z (&(*self));
	_tmp7_ = _tmp6_;
	engine_quat_init_vals (&_tmp8_, _tmp1_ / scalar, _tmp3_ / scalar, _tmp5_ / scalar, _tmp7_ / scalar);
	*result = _tmp8_;
	return;
}

gfloat
engine_quat_dot (EngineQuat *self,
                 EngineQuat* other)
{
	gfloat _tmp0_;
	gfloat _tmp1_;
	EngineQuat _tmp2_;
	gfloat _tmp3_;
	gfloat _tmp4_;
	gfloat _tmp5_;
	gfloat _tmp6_;
	EngineQuat _tmp7_;
	gfloat _tmp8_;
	gfloat _tmp9_;
	gfloat _tmp10_;
	gfloat _tmp11_;
	EngineQuat _tmp12_;
	gfloat _tmp13_;
	gfloat _tmp14_;
	gfloat _tmp15_;
	gfloat _tmp16_;
	EngineQuat _tmp17_;
	gfloat _tmp18_;
	gfloat _tmp19_;
	gfloat result = 0.0F;
	g_return_val_if_fail (other != NULL, 0.0F);
	_tmp0_ = engine_quat_get_w (&(*self));
	_tmp1_ = _tmp0_;
	_tmp2_ = *other;
	_tmp3_ = engine_quat_get_w (&_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = engine_quat_get_x (&(*self));
	_tmp6_ = _tmp5_;
	_tmp7_ = *other;
	_tmp8_ = engine_quat_get_x (&_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = engine_quat_get_y (&(*self));
	_tmp11_ = _tmp10_;
	_tmp12_ = *other;
	_tmp13_ = engine_quat_get_y (&_tmp12_);
	_tmp14_ = _tmp13_;
	_tmp15_ = engine_quat_get_z (&(*self));
	_tmp16_ = _tmp15_;
	_tmp17_ = *other;
	_tmp18_ = engine_quat_get_z (&_tmp17_);
	_tmp19_ = _tmp18_;
	result = (((_tmp1_ * _tmp4_) + (_tmp6_ * _tmp9_)) + (_tmp11_ * _tmp14_)) + (_tmp16_ * _tmp19_);
	return result;
}

void
engine_quat_inv (EngineQuat *self,
                 EngineQuat* result)
{
	gfloat l = 0.0F;
	gfloat _tmp0_;
	gfloat _tmp1_;
	gfloat _tmp2_;
	gfloat _tmp3_;
	gfloat _tmp4_;
	gfloat _tmp5_;
	gfloat _tmp6_;
	gfloat _tmp7_;
	gfloat _tmp8_;
	gfloat _tmp9_;
	gfloat _tmp10_;
	gfloat _tmp11_;
	gfloat _tmp12_;
	gfloat _tmp13_;
	gfloat _tmp14_;
	gfloat _tmp15_;
	EngineQuat _tmp16_ = {0};
	EngineQuat _tmp17_ = {0};
	_tmp0_ = engine_quat_get_w (&(*self));
	_tmp1_ = _tmp0_;
	_tmp2_ = engine_quat_get_w (&(*self));
	_tmp3_ = _tmp2_;
	_tmp4_ = engine_quat_get_x (&(*self));
	_tmp5_ = _tmp4_;
	_tmp6_ = engine_quat_get_x (&(*self));
	_tmp7_ = _tmp6_;
	_tmp8_ = engine_quat_get_y (&(*self));
	_tmp9_ = _tmp8_;
	_tmp10_ = engine_quat_get_y (&(*self));
	_tmp11_ = _tmp10_;
	_tmp12_ = engine_quat_get_z (&(*self));
	_tmp13_ = _tmp12_;
	_tmp14_ = engine_quat_get_z (&(*self));
	_tmp15_ = _tmp14_;
	l = (((_tmp1_ * _tmp3_) + (_tmp5_ * _tmp7_)) + (_tmp9_ * _tmp11_)) + (_tmp13_ * _tmp15_);
	engine_quat_conjugate (&(*self), &_tmp16_);
	engine_quat_div_scalar (&_tmp16_, l, &_tmp17_);
	*result = _tmp17_;
	return;
}

void
engine_quat_norm (EngineQuat *self,
                  EngineQuat* result)
{
	gfloat l = 0.0F;
	EngineQuat _tmp0_ = {0};
	l = engine_quat_len (&(*self));
	engine_quat_div_scalar (&(*self), l, &_tmp0_);
	*result = _tmp0_;
	return;
}

void
engine_quat_neg (EngineQuat *self,
                 EngineQuat* result)
{
	gfloat _tmp0_;
	gfloat _tmp1_;
	gfloat _tmp2_;
	gfloat _tmp3_;
	gfloat _tmp4_;
	gfloat _tmp5_;
	gfloat _tmp6_;
	gfloat _tmp7_;
	EngineQuat _tmp8_ = {0};
	_tmp0_ = engine_quat_get_w (&(*self));
	_tmp1_ = _tmp0_;
	_tmp2_ = engine_quat_get_x (&(*self));
	_tmp3_ = _tmp2_;
	_tmp4_ = engine_quat_get_y (&(*self));
	_tmp5_ = _tmp4_;
	_tmp6_ = engine_quat_get_z (&(*self));
	_tmp7_ = _tmp6_;
	engine_quat_init_vals (&_tmp8_, -_tmp1_, -_tmp3_, -_tmp5_, -_tmp7_);
	*result = _tmp8_;
	return;
}

void
engine_quat_conjugate (EngineQuat *self,
                       EngineQuat* result)
{
	gfloat _tmp0_;
	gfloat _tmp1_;
	gfloat _tmp2_;
	gfloat _tmp3_;
	gfloat _tmp4_;
	gfloat _tmp5_;
	gfloat _tmp6_;
	gfloat _tmp7_;
	EngineQuat _tmp8_ = {0};
	_tmp0_ = engine_quat_get_w (&(*self));
	_tmp1_ = _tmp0_;
	_tmp2_ = engine_quat_get_x (&(*self));
	_tmp3_ = _tmp2_;
	_tmp4_ = engine_quat_get_y (&(*self));
	_tmp5_ = _tmp4_;
	_tmp6_ = engine_quat_get_z (&(*self));
	_tmp7_ = _tmp6_;
	engine_quat_init_vals (&_tmp8_, _tmp1_, -_tmp3_, -_tmp5_, -_tmp7_);
	*result = _tmp8_;
	return;
}

void
engine_quat_to_euler (EngineQuat *self,
                      EngineVec3* result)
{
	gfloat ysqr = 0.0F;
	gfloat _tmp0_;
	gfloat _tmp1_;
	gfloat _tmp2_;
	gfloat _tmp3_;
	gfloat t0 = 0.0F;
	gfloat _tmp4_;
	gfloat _tmp5_;
	gfloat _tmp6_;
	gfloat _tmp7_;
	gfloat _tmp8_;
	gfloat _tmp9_;
	gfloat _tmp10_;
	gfloat _tmp11_;
	gfloat t1 = 0.0F;
	gfloat _tmp12_;
	gfloat _tmp13_;
	gfloat _tmp14_;
	gfloat _tmp15_;
	gfloat pitch = 0.0F;
	gfloat t2 = 0.0F;
	gfloat _tmp16_;
	gfloat _tmp17_;
	gfloat _tmp18_;
	gfloat _tmp19_;
	gfloat _tmp20_;
	gfloat _tmp21_;
	gfloat _tmp22_;
	gfloat _tmp23_;
	gfloat _tmp24_ = 0.0F;
	gfloat _tmp25_ = 0.0F;
	gfloat yaw = 0.0F;
	gfloat t3 = 0.0F;
	gfloat _tmp26_;
	gfloat _tmp27_;
	gfloat _tmp28_;
	gfloat _tmp29_;
	gfloat _tmp30_;
	gfloat _tmp31_;
	gfloat _tmp32_;
	gfloat _tmp33_;
	gfloat t4 = 0.0F;
	gfloat _tmp34_;
	gfloat _tmp35_;
	gfloat _tmp36_;
	gfloat _tmp37_;
	gfloat roll = 0.0F;
	EngineVec3 _tmp38_ = {0};
	EngineVec3 _tmp39_ = {0};
	_tmp0_ = engine_quat_get_y (&(*self));
	_tmp1_ = _tmp0_;
	_tmp2_ = engine_quat_get_y (&(*self));
	_tmp3_ = _tmp2_;
	ysqr = _tmp1_ * _tmp3_;
	_tmp4_ = engine_quat_get_w (&(*self));
	_tmp5_ = _tmp4_;
	_tmp6_ = engine_quat_get_x (&(*self));
	_tmp7_ = _tmp6_;
	_tmp8_ = engine_quat_get_y (&(*self));
	_tmp9_ = _tmp8_;
	_tmp10_ = engine_quat_get_z (&(*self));
	_tmp11_ = _tmp10_;
	t0 = 2 * ((_tmp5_ * _tmp7_) + (_tmp9_ * _tmp11_));
	_tmp12_ = engine_quat_get_x (&(*self));
	_tmp13_ = _tmp12_;
	_tmp14_ = engine_quat_get_x (&(*self));
	_tmp15_ = _tmp14_;
	t1 = 1 - (2 * ((_tmp13_ * _tmp15_) + ysqr));
	pitch = atan2f (t0, t1);
	_tmp16_ = engine_quat_get_w (&(*self));
	_tmp17_ = _tmp16_;
	_tmp18_ = engine_quat_get_y (&(*self));
	_tmp19_ = _tmp18_;
	_tmp20_ = engine_quat_get_z (&(*self));
	_tmp21_ = _tmp20_;
	_tmp22_ = engine_quat_get_x (&(*self));
	_tmp23_ = _tmp22_;
	t2 = 2 * ((_tmp17_ * _tmp19_) - (_tmp21_ * _tmp23_));
	if (t2 > ((gfloat) 1)) {
		_tmp24_ = (gfloat) 1;
	} else {
		_tmp24_ = t2;
	}
	t2 = _tmp24_;
	if (t2 < ((gfloat) -1)) {
		_tmp25_ = (gfloat) -1;
	} else {
		_tmp25_ = t2;
	}
	t2 = _tmp25_;
	yaw = asinf (t2);
	_tmp26_ = engine_quat_get_w (&(*self));
	_tmp27_ = _tmp26_;
	_tmp28_ = engine_quat_get_z (&(*self));
	_tmp29_ = _tmp28_;
	_tmp30_ = engine_quat_get_x (&(*self));
	_tmp31_ = _tmp30_;
	_tmp32_ = engine_quat_get_y (&(*self));
	_tmp33_ = _tmp32_;
	t3 = 2 * ((_tmp27_ * _tmp29_) + (_tmp31_ * _tmp33_));
	_tmp34_ = engine_quat_get_z (&(*self));
	_tmp35_ = _tmp34_;
	_tmp36_ = engine_quat_get_z (&(*self));
	_tmp37_ = _tmp36_;
	t4 = 1 - (2 * (ysqr + (_tmp35_ * _tmp37_)));
	roll = atan2f (t3, t4);
	engine_vec3_init (&_tmp38_, yaw, pitch, roll);
	engine_vec3_div_scalar (&_tmp38_, (gfloat) G_PI, &_tmp39_);
	*result = _tmp39_;
	return;
}

void
engine_quat_slerp (EngineQuat* from,
                   EngineQuat* to,
                   gfloat t,
                   EngineQuat* result)
{
	gfloat cosom = 0.0F;
	EngineQuat _tmp0_;
	EngineQuat nto = {0};
	EngineQuat _tmp1_;
	gfloat scale0 = 0.0F;
	gfloat scale1 = 0.0F;
	EngineQuat _tmp3_;
	gfloat _tmp4_;
	gfloat _tmp5_;
	EngineQuat _tmp6_;
	gfloat _tmp7_;
	gfloat _tmp8_;
	EngineQuat _tmp9_;
	gfloat _tmp10_;
	gfloat _tmp11_;
	EngineQuat _tmp12_;
	gfloat _tmp13_;
	gfloat _tmp14_;
	EngineQuat _tmp15_;
	gfloat _tmp16_;
	gfloat _tmp17_;
	EngineQuat _tmp18_;
	gfloat _tmp19_;
	gfloat _tmp20_;
	EngineQuat _tmp21_;
	gfloat _tmp22_;
	gfloat _tmp23_;
	EngineQuat _tmp24_;
	gfloat _tmp25_;
	gfloat _tmp26_;
	EngineQuat _tmp27_ = {0};
	g_return_if_fail (from != NULL);
	g_return_if_fail (to != NULL);
	_tmp0_ = *to;
	cosom = engine_quat_dot (from, &_tmp0_);
	_tmp1_ = *to;
	nto = _tmp1_;
	if (((gdouble) cosom) < 0.0) {
		EngineQuat _tmp2_ = {0};
		cosom = -cosom;
		engine_quat_neg (to, &_tmp2_);
		nto = _tmp2_;
	}
	if (cosom < ENGINE_QUAT_SLERP_THRESHOLD) {
		gfloat omega = 0.0F;
		gfloat sinom = 0.0F;
		omega = (gfloat) acos ((gdouble) cosom);
		sinom = (gfloat) sin ((gdouble) omega);
		scale0 = ((gfloat) sin ((1.0 - t) * omega)) / sinom;
		scale1 = ((gfloat) sin ((gdouble) (t * omega))) / sinom;
	} else {
		scale0 = 1 - t;
		scale1 = t;
	}
	_tmp3_ = *from;
	_tmp4_ = engine_quat_get_w (&_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = nto;
	_tmp7_ = engine_quat_get_w (&_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = *from;
	_tmp10_ = engine_quat_get_x (&_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = nto;
	_tmp13_ = engine_quat_get_x (&_tmp12_);
	_tmp14_ = _tmp13_;
	_tmp15_ = *from;
	_tmp16_ = engine_quat_get_y (&_tmp15_);
	_tmp17_ = _tmp16_;
	_tmp18_ = nto;
	_tmp19_ = engine_quat_get_y (&_tmp18_);
	_tmp20_ = _tmp19_;
	_tmp21_ = *from;
	_tmp22_ = engine_quat_get_z (&_tmp21_);
	_tmp23_ = _tmp22_;
	_tmp24_ = nto;
	_tmp25_ = engine_quat_get_z (&_tmp24_);
	_tmp26_ = _tmp25_;
	engine_quat_init_vals (&_tmp27_, (scale0 * _tmp5_) + (scale1 * _tmp8_), (scale0 * _tmp11_) + (scale1 * _tmp14_), (scale0 * _tmp17_) + (scale1 * _tmp20_), (scale0 * _tmp23_) + (scale1 * _tmp26_));
	*result = _tmp27_;
	return;
}

gfloat
engine_quat_get_w (EngineQuat* self)
{
	gfloat result;
	g_return_val_if_fail (self != NULL, 0.0F);
	result = (*self)._w;
	return result;
}

static void
engine_quat_set_w (EngineQuat* self,
                   gfloat value)
{
	g_return_if_fail (self != NULL);
	(*self)._w = value;
}

gfloat
engine_quat_get_x (EngineQuat* self)
{
	gfloat result;
	g_return_val_if_fail (self != NULL, 0.0F);
	result = (*self)._x;
	return result;
}

static void
engine_quat_set_x (EngineQuat* self,
                   gfloat value)
{
	g_return_if_fail (self != NULL);
	(*self)._x = value;
}

gfloat
engine_quat_get_y (EngineQuat* self)
{
	gfloat result;
	g_return_val_if_fail (self != NULL, 0.0F);
	result = (*self)._y;
	return result;
}

static void
engine_quat_set_y (EngineQuat* self,
                   gfloat value)
{
	g_return_if_fail (self != NULL);
	(*self)._y = value;
}

gfloat
engine_quat_get_z (EngineQuat* self)
{
	gfloat result;
	g_return_val_if_fail (self != NULL, 0.0F);
	result = (*self)._z;
	return result;
}

static void
engine_quat_set_z (EngineQuat* self,
                   gfloat value)
{
	g_return_if_fail (self != NULL);
	(*self)._z = value;
}

EngineQuat*
engine_quat_dup (const EngineQuat* self)
{
	EngineQuat* dup;
	dup = g_new0 (EngineQuat, 1);
	memcpy (dup, self, sizeof (EngineQuat));
	return dup;
}

void
engine_quat_free (EngineQuat* self)
{
	g_free (self);
}

static GType
engine_quat_get_type_once (void)
{
	GType engine_quat_type_id;
	engine_quat_type_id = g_boxed_type_register_static ("EngineQuat", (GBoxedCopyFunc) engine_quat_dup, (GBoxedFreeFunc) engine_quat_free);
	return engine_quat_type_id;
}

GType
engine_quat_get_type (void)
{
	static volatile gsize engine_quat_type_id__volatile = 0;
	if (g_once_init_enter (&engine_quat_type_id__volatile)) {
		GType engine_quat_type_id;
		engine_quat_type_id = engine_quat_get_type_once ();
		g_once_init_leave (&engine_quat_type_id__volatile, engine_quat_type_id);
	}
	return engine_quat_type_id__volatile;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

